plugins["colors"] = {
  version: "v1.0.2",
  lastChange: "Nov 19th, 2008",
  displayName: "Colors",
  directory: currentDirectory,
  icon: currentDirectory + "\\colors.ico",
  aliasstr: "colors",
  regexstr: "^" + this.aliasstr + " ?(.*)", // XXX: not using...
  regexobj: /^colors ?(.*)/, // to get one-time compilation of the regex
  _colorsData: {"red": "#FF0000", "green": "#00FF00", "blue": "#0000FF",
                "grey": "#909090"},
  search: function(querykey, explicit, queryraw, querynokeyword, 
                   modifier, triggermethod) {
    if (!explicit) return;
    var m_array = queryraw.match(this.regexobj);
    if (!m_array) return;
    var m_arg = m_array[1];
    for (var color in this._colorsData) {
      if (color.indexOf(m_arg) == 0) {
        FARR.emitResult(querykey, color, "colors", this.icon, CLIP, 
                        ADD_SCORE_W_PATS, 10000, "colors");
                        //MATCH_AGAINST_SEARCH, 10000, color); // XXX
      } 
    } 
  }, 
  trigger: function(path, title, groupname, pluginid, thispluginid, 
                    score, entrytype, args) {
    if (groupname != "colors") { return; }
    if (!(title in this._colorsData)) { return; }
    pasteClipboardToLastActiveWindow(this._colorsData[title]);
    return HANDLED|CLOSE;
  }, 
  showSettings: function() {
    FARR.debug("showSettings");
    //FARR.exec(this.directory+"\\colorsSettings.ahk");
  }
}
